#!/usr/bin/perl

# Copyright (C) 2003-2010 NEC Corporation
# All Rights Reserved.


# եåΥ⡼
$WBMC_LOCK_R_B = 1;	# ɤ߹ߥå(֥å⡼)
$WBMC_LOCK_W_B = 2;	# 񤭹ߥå(֥å⡼)
$WBMC_LOCK_R_NB = 5;	# ɤ߹ߥå(Υ֥å⡼)
$WBMC_LOCK_W_NB = 6;	# 񤭹ߥå(Υ֥å⡼)

#
# ̾
#	lockFile - ꤵ줿ե˥å򤫤
# 
#	lockFile($lockfile, $mode, *LOCK)
# 
#	$lockfile åե̾(/opt/nec/wbmc/adm/service/ESMPRO_AC/β˺)
#	$mode åΥ⡼(β줫)
#		$WBMC_LOCK_R_B  ɤ߹ߥå(֥å⡼)
#		$WBMC_LOCK_W_B  񤭹ߥå(֥å⡼)
#		$WBMC_LOCK_R_NB ɤ߹ߥå(Υ֥å⡼)
#		$WBMC_LOCK_W_NB 񤭹ߥå(Υ֥å⡼)
#	*LOCK եϥɥ
#		åˤϤΥեϥɥclose
# 
#	ΤȤ1
#	ԤΤȤ0
#
sub lockFile
{
    local($lockfile, $mode, *LOCK) = @_;

    my($ret);
    my($lockdir);

    $ret = 0;
    $lockdir = "/opt/nec/wbmc/adm/service/ESMPRO_AC/";

    if ($lockfile eq "") {
	goto done;
    }

    # åեѤΥǥ쥯ȥ(̵)
    if (! -d $lockdir) {
	if (!mkdir($lockdir, 0755)) {
	    goto done;
	}
    }

    # åե򥪡ץ󤹤
    if (!open(LOCK, "> $lockdir/$lockfile")) {
	goto done;
    }

    # å򤫤
    if (!flock(LOCK, $mode)) {
	close(LOCK);
	goto done;
    }

    $ret = 1;

done:
    return($ret);
}

#---------------------------------------------------------------------------

#
# ̾
#	WriteConfigFileEx ꤵ줿ե뤫ǡɤ߹
# 
#	WriteConfigFileEx( $file_name, $sec_name, $param_name, $value )
# 
#	
# 
#	ΤȤ0
#	ԤΤȤ-1
#
sub WriteConfigFileEx
{
	local( $file_name, $sec_name, $param_name, $value ) = @_;
	local( $esmini_file );
	local( $read_fp );
	local( $write_fp );
	local( $current_section );

	local( $return_string );

	local( @pram_list );
	local( $left_name );
	local( $right_name );
	local( @tmp_list1 );
	local( @tmp_list2 );

	local( $tmpcfname );
	local( $err );
	local( $len );

	local( $temp );
	local( $buff );
	local( $newsection_flag );
	local( $newparam_flag );


	if( !&lockFile( "esmaclock", "$WBMC_LOCK_W_B", *LOCK) ) {
		$err = "եΥץ˼Ԥޤ($NAMEDLOCKFILE) ١ƱͤԤäƤ";
#		&showErrorPage( "$err" );
		exit(1);
	}

	$tmpcfname = "$file_name\.tmp";
	if( !open(OUT, "> $tmpcfname") ) {
		close(LOCK);
		$err = "եΥץ˼Ԥޤ($tmpcfname) ١ƱͤԤäƤtest1";
#		&showErrorPage("$err");
		exit(1);
	}
	$write_fp = OUT;
	

	if( open( esmini_file, "<$file_name" ) ) {
#		close(LOCK);
#		$err = "եΥץ˼Ԥޤ($file_name) ١ƱͤԤäƤtest2";
#		&showErrorPage("$err");
#		exit(1);
#	}

		$read_fp = esmini_file;
	
		$buff = "";
		$current_section = "";
		$newsection_flag = "0";
		$newparam_flag = "0";
		while( <$read_fp> ) {
			chop;
			@pram_list = split( /=/, $_ );
			$left_name = @pram_list[0];
#			$left_name =~ s/\t//g;
#			$left_name =~ s/\s//g;
			$right_name = @pram_list[1];
#			$right_name =~ s/\t//g;
#			$right_name =~ s/\s//;
			
			
			@tmp_list1 = split( /\[/, $left_name );
			@tmp_list2 = split( /\]/, @tmp_list1[1] );
			if ( (@pram_list[1] eq "") &&
				 (@tmp_list1[1] ne "") &&
				 (@tmp_list2[0] ne "") ) {
	
				# оݤΥ¸ߤƤΤ˼ΥѤäƤޤä
				# 硢ͤɲä
				if( ($newsection_flag eq "1") &&
					($newparam_flag eq "0") ) {
	
					$temp = $buff;
#					$buff = sprintf( "%s%s\t= %s\n", $temp, $param_name, $value );
					$buff = sprintf( "%s%s=%s\n", $temp, $param_name, $value );
					
					# ͤɲä
					$newparam_flag = "1";
				}
				
				# ߤΥ̾򹹿
				$current_section = @tmp_list2[0];
	
				$temp = $buff;
				$buff = sprintf( "%s\n%s\n", $temp, $left_name );
				
			}
			# оݤȤʤä
			elsif ( $current_section eq $sec_name ) {
	
				# ¸ߤ
				$newsection_flag = "1";
	
				# оݤȤʤä
				if ( $left_name eq $param_name ) {
					$temp = $buff;
#					$buff = sprintf( "%s%s\t= %s\n", $temp, $param_name, $value );
					$buff = sprintf( "%s%s=%s\n", $temp, $param_name, $value );
					
					# ͤ򹹿
					$newparam_flag = "1";
				}
				else {
					if( $left_name ne "" ) {
						$temp = $buff;
#						$buff = sprintf( "%s%s\t= %s\n", $temp, $left_name, $right_name );
						$buff = sprintf( "%s%s=%s\n", $temp, $left_name, $right_name );
					}
				}
			}
			# ¾
			else {
				if( $left_name ne "" ) {
					$temp = $buff;
#					$buff = sprintf( "%s%s\t= %s\n", $temp, $left_name, $right_name );
					$buff = sprintf( "%s%s=%s\n", $temp, $left_name, $right_name );
				}
			}
		}
		
		#
		close( esmini_file );
	}
	
	# 륻󤬤ʤä硢ɲä
	if( $newsection_flag == 0 ) {
		# ͤɲ
		$temp = $buff;
#		$buff = sprintf( "%s[%s]\n%s\t= %s\n", $temp, $sec_name, $param_name, $value );
		$buff = sprintf( "%s[%s]\n%s=%s\n", $temp, $sec_name, $param_name, $value );

	}
	# ͤ񤭹Ƥʤɲä
	# Υե饰ξˤϡǽɲоݤΥˤʤΤǡ
	# ͤΤߤɲäOK
	if( $newparam_flag eq "0" ) {
		$temp = sprintf( "%s", $buff );
#		$buff = sprintf( "%s%s\t= %s\n", $temp, $param_name, $value );
		$buff = sprintf( "%s%s=%s\n", $temp, $param_name, $value );
	}

	# եؤν񤭹
	$len = length( $buff );
	$err = syswrite( $write_fp, $buff, $len );
	
	close( OUT );
	close( LOCK );

	if ($err == $len) {
		rename($tmpcfname, $file_name);
	}
	else {
		unlink($tmpcfname);
		$err = "եν񤭹ߤ˼Ԥޤ($tmpcfname)";
#		&showErrorPage("$err");
		exit(1);
	}


	return 0;
}

if( $ARGV[0] eq "0" ) {	#߹۲ǽʹɽ
	WriteConfigFileEx( "/usr/local/AUTORC/data/snmp.apc", "SNMP", "IPMI_NOT_USE_SA", "0" );
}
elsif( $ARGV[0] eq "1" ) {	#߹۲ǽʹɽ
	WriteConfigFileEx( "/usr/local/AUTORC/data/snmp.apc", "SNMP", "IPMI_NOT_USE_SA", "1" );
}


